'use strict';

var _log4js = require('log4js');

var _documentStorage = require('../../document-storage');

var _documentStorage2 = _interopRequireDefault(_documentStorage);

var _astHelper = require('../../ast-helper');

var _astHelper2 = _interopRequireDefault(_astHelper);

var _extractFunction = require('../extract-function');

var _extractFunction2 = _interopRequireDefault(_extractFunction);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mock = (0, _utils.createMock)(_extractFunction2.default);

test('should suggest fix', () => {
  const code = `
const a = 1
const b = 2
console.log(a, b)
`;

  const range = { start: { line: 0, character: 0 }, end: { line: 4, character: 0 } };
  const commands = mock.suggest(code, { range });

  expect(commands.length).toBe(1);
  expect(commands[0].command).toBe('extract_function');
  expect(commands[0].title).toMatch('Extract function');
});

//test('should not suggest fix if arrow already has implicit return', () => {
//const code = `const foo = () => 1`
//const commands = mock.suggest(code, 0, 15)

//expect(commands.length).toBe(0)
//})

//test('should not suggest fix if arrow has no return statement', () => {
//const code = `const foo = () => {
//console.log('something')
//}`
//const commands = mock.suggest(code, 0, 15)

//expect(commands.length).toBe(0)
//})

test('should extract function', () => {
  const code = `
const a = 1
const b = 2
console.log(a, b)
`;

  const range = { start: { line: 0, character: 0 }, end: { line: 4, character: 0 } };
  const edit = mock.edit(0, code, { range });

  const expected = `const extracted_func = () => {
  const a = 1
  const b = 2
  console.log(a, b)
}
extracted_func()
`;

  const change = Object.values(edit.changes)[0];
  expect(change).toEqual([{
    newText: expected,
    range: { start: { line: 0, character: 12 }, end: { line: 0, character: 29 } }
  }]);
});

//test('should copy params convert body', () => {
//const code = `const foo = (a) => {return a;}`
//const edit = mock.edit(0, code, 0, 15)

//const expected = `a => a`

//const change = Object.values(edit.changes)[0]
//expect(change).toEqual([
//{
//newText: expected,
//range: {start: {line: 0, character: 12}, end: {line: 0, character: 30}},
//},
//])
//})